.deb dependencies from Python packages ignore iteration.
[arvados-dev.git] / jenkins / run-library.sh
1 #!/bin/bash
2
3 # A library of functions shared by the various scripts in this directory.
4
5 # This is the timestamp about when we merged changed to include licenses
6 # with Arvados packages.  We use it as a heuristic to add revisions for
7 # older packages.
8 LICENSE_PACKAGE_TS=20151208015500
9
10 debug_echo () {
11     echo "$@" >"$STDOUT_IF_DEBUG"
12 }
13
14 find_easy_install() {
15     for version_suffix in "$@"; do
16         if "easy_install$version_suffix" --version >/dev/null 2>&1; then
17             echo "easy_install$version_suffix"
18             return 0
19         fi
20     done
21     cat >&2 <<EOF
22 $helpmessage
23
24 Error: easy_install$1 (from Python setuptools module) not found
25
26 EOF
27     exit 1
28 }
29
30 format_last_commit_here() {
31     local format="$1"; shift
32     TZ=UTC git log -n1 --first-parent "--format=format:$format" .
33 }
34
35 version_from_git() {
36   # Generates a version number from the git log for the current working
37   # directory, and writes it to stdout.
38   local git_ts git_hash
39   declare $(format_last_commit_here "git_ts=%ct git_hash=%h")
40   echo "0.1.$(date -ud "@$git_ts" +%Y%m%d%H%M%S).$git_hash"
41 }
42
43 nohash_version_from_git() {
44     version_from_git | cut -d. -f1-3
45 }
46
47 timestamp_from_git() {
48     format_last_commit_here "%ct"
49 }
50
51 handle_python_package () {
52   # This function assumes the current working directory is the python package directory
53   if [ -n "$(find dist -name "*-$(nohash_version_from_git).tar.gz" -print -quit)" ]; then
54     # This package doesn't need rebuilding.
55     return
56   fi
57   # Make sure only to use sdist - that's the only format pip can deal with (sigh)
58   python setup.py $DASHQ_UNLESS_DEBUG sdist
59 }
60
61 handle_ruby_gem() {
62     local gem_name="$1"; shift
63     local gem_version="$(nohash_version_from_git)"
64     local gem_src_dir="$(pwd)"
65
66     if ! [[ -e "${gem_name}-${gem_version}.gem" ]]; then
67         find -maxdepth 1 -name "${gem_name}-*.gem" -delete
68
69         # -q appears to be broken in gem version 2.2.2
70         $GEM build "$gem_name.gemspec" $DASHQ_UNLESS_DEBUG >"$STDOUT_IF_DEBUG" 2>"$STDERR_IF_DEBUG"
71     fi
72 }
73
74 # Usage: package_go_binary services/foo arvados-foo "Compute foo to arbitrary precision"
75 package_go_binary() {
76     local src_path="$1"; shift
77     local prog="$1"; shift
78     local description="$1"; shift
79     local license_file="${1:-agpl-3.0.txt}"; shift
80
81     debug_echo "package_go_binary $src_path as $prog"
82
83     local basename="${src_path##*/}"
84
85     mkdir -p "$GOPATH/src/git.curoverse.com"
86     ln -sfn "$WORKSPACE" "$GOPATH/src/git.curoverse.com/arvados.git"
87
88     cd "$GOPATH/src/git.curoverse.com/arvados.git/$src_path"
89     local version="$(version_from_git)"
90     local timestamp="$(timestamp_from_git)"
91
92     # If the command imports anything from the Arvados SDK, bump the
93     # version number and build a new package whenever the SDK changes.
94     if grep -qr git.curoverse.com/arvados .; then
95         cd "$GOPATH/src/git.curoverse.com/arvados.git/sdk/go"
96         if [[ $(timestamp_from_git) -gt "$timestamp" ]]; then
97             version=$(version_from_git)
98         fi
99     fi
100
101     cd $WORKSPACE/packages/$TARGET
102     go get "git.curoverse.com/arvados.git/$src_path"
103     fpm_build "$GOPATH/bin/$basename=/usr/bin/$prog" "$prog" 'Curoverse, Inc.' dir "$version" "--url=https://arvados.org" "--license=GNU Affero General Public License, version 3.0" "--description=$description" "$WORKSPACE/$license_file=/usr/share/doc/$prog/$license_file"
104 }
105
106 default_iteration() {
107     local package_name="$1"; shift
108     local package_version="$1"; shift
109     local iteration=1
110     if [[ $package_version =~ ^0\.1\.([0-9]{14})(\.|$) ]] && \
111            [[ ${BASH_REMATCH[1]} -le $LICENSE_PACKAGE_TS ]]; then
112         iteration=2
113     fi
114     echo $iteration
115 }
116
117 _build_rails_package_scripts() {
118     local pkgname="$1"; shift
119     local destdir="$1"; shift
120     local srcdir="$RUN_BUILD_PACKAGES_PATH/rails-package-scripts"
121     for scriptname in postinst prerm postrm; do
122         cat "$srcdir/$pkgname.sh" "$srcdir/step2.sh" "$srcdir/$scriptname.sh" \
123             >"$destdir/$scriptname" || return $?
124     done
125 }
126
127 handle_rails_package() {
128     local pkgname="$1"; shift
129     local srcdir="$1"; shift
130     local license_path="$1"; shift
131     local scripts_dir="$(mktemp --tmpdir -d "$pkgname-XXXXXXXX.scripts")" && \
132     local version_file="$(mktemp --tmpdir "$pkgname-XXXXXXXX.version")" && (
133         set -e
134         _build_rails_package_scripts "$pkgname" "$scripts_dir"
135         cd "$srcdir"
136         mkdir -p tmp
137         version_from_git >"$version_file"
138         git rev-parse HEAD >git-commit.version
139         bundle package --all
140     )
141     if [[ 0 != "$?" ]] || ! cd "$WORKSPACE/packages/$TARGET"; then
142         echo "ERROR: $pkgname package prep failed" >&2
143         rm -rf "$scripts_dir" "$version_file"
144         EXITCODE=1
145         return 1
146     fi
147     local railsdir="/var/www/${pkgname%-server}/current"
148     local -a pos_args=("$srcdir/=$railsdir" "$pkgname" "Curoverse, Inc." dir
149                        "$(cat "$version_file")")
150     local license_arg="$license_path=$railsdir/$(basename "$license_path")"
151     # --iteration=3 accommodates the package scripts change from #8014.
152     # --iteration=4 accommodates the packaging changes (inclusion of vendor/cache) from #8008.
153     local -a switches=(--iteration=4
154                        --after-install "$scripts_dir/postinst"
155                        --before-remove "$scripts_dir/prerm"
156                        --after-remove "$scripts_dir/postrm")
157     # For some reason fpm excludes need to not start with /.
158     local exclude_root="${railsdir#/}"
159     # .git and packages are for the SSO server, which is built from its
160     # repository root.
161     local -a exclude_list=(.git packages tmp log coverage Capfile\* \
162                            config/deploy\* config/application.yml)
163     # for arvados-workbench, we need to have the (dummy) config/database.yml in the package
164     if  [[ "$pkgname" != "arvados-workbench" ]]; then
165       exclude_list+=('config/database.yml')
166     fi
167     for exclude in ${exclude_list[@]}; do
168         switches+=(-x "$exclude_root/$exclude")
169     done
170     fpm_build "${pos_args[@]}" "${switches[@]}" \
171               -x "$exclude_root/vendor/bundle" "$@" "$license_arg"
172     rm -rf "$scripts_dir" "$version_file"
173 }
174
175 # Build packages for everything
176 fpm_build () {
177   # The package source.  Depending on the source type, this can be a
178   # path, or the name of the package in an upstream repository (e.g.,
179   # pip).
180   PACKAGE=$1
181   shift
182   # The name of the package to build.  Defaults to $PACKAGE.
183   PACKAGE_NAME=${1:-$PACKAGE}
184   shift
185   # Optional: the vendor of the package.  Should be "Curoverse, Inc." for
186   # packages of our own software.  Passed to fpm --vendor.
187   VENDOR=$1
188   shift
189   # The type of source package.  Passed to fpm -s.  Default "python".
190   PACKAGE_TYPE=${1:-python}
191   shift
192   # Optional: the package version number.  Passed to fpm -v.
193   VERSION=$1
194   shift
195
196   case "$PACKAGE_TYPE" in
197       python)
198           # All Arvados Python2 packages depend on Python 2.7.
199           # Make sure we build with that for consistency.
200           set -- "$@" --python-bin python2.7 \
201               --python-easyinstall "$EASY_INSTALL2" \
202               --python-package-name-prefix "$PYTHON2_PKG_PREFIX" \
203               --depends "$PYTHON2_PACKAGE"
204           ;;
205       python3)
206           # fpm does not actually support a python3 package type.  Instead
207           # we recognize it as a convenience shortcut to add several
208           # necessary arguments to fpm's command line later, after we're
209           # done handling positional arguments.
210           PACKAGE_TYPE=python
211           set -- "$@" --python-bin python3 \
212               --python-easyinstall "$EASY_INSTALL3" \
213               --python-package-name-prefix "$PYTHON3_PKG_PREFIX" \
214               --depends "$PYTHON3_PACKAGE"
215           ;;
216   esac
217
218   declare -a COMMAND_ARR=("fpm" "--maintainer=Ward Vandewege <ward@curoverse.com>" "-s" "$PACKAGE_TYPE" "-t" "$FORMAT")
219   if [ python = "$PACKAGE_TYPE" ]; then
220     COMMAND_ARR+=(--exclude=\*/{dist,site}-packages/tests/\*)
221     if [ deb = "$FORMAT" ]; then
222         # Dependencies are built from setup.py.  Since setup.py will never
223         # refer to Debian package iterations, it doesn't make sense to
224         # enforce those in the .deb dependencies.
225         COMMAND_ARR+=(--deb-ignore-iteration-in-dependencies)
226     fi
227   fi
228
229   if [[ "$PACKAGE_NAME" != "$PACKAGE" ]]; then
230     COMMAND_ARR+=('-n' "$PACKAGE_NAME")
231   fi
232
233   if [[ "$VENDOR" != "" ]]; then
234     COMMAND_ARR+=('--vendor' "$VENDOR")
235   fi
236
237   if [[ "$VERSION" != "" ]]; then
238     COMMAND_ARR+=('-v' "$VERSION")
239   fi
240   # We can always add an --iteration here.  If another one is specified in $@,
241   # that will take precedence, as desired.
242   COMMAND_ARR+=(--iteration "$(default_iteration "$PACKAGE" "$VERSION")")
243
244   # 'dir' type packages are provided in the form /path/to/source=/path/to/dest
245   # so strip off the 2nd part to check for fpm-info below.
246   PACKAGE_DIR=$(echo $PACKAGE | sed 's/\/=.*//')
247
248   # Append --depends X and other arguments specified by fpm-info.sh in
249   # the package source dir. These are added last so they can override
250   # the arguments added by this script.
251   declare -a fpm_args=()
252   declare -a fpm_depends=()
253   declare -a fpm_exclude=()
254   if [[ -d "$PACKAGE_DIR" ]]; then
255       FPM_INFO="$PACKAGE_DIR/fpm-info.sh"
256   else
257       FPM_INFO="${WORKSPACE}/backports/${PACKAGE_TYPE}-${PACKAGE}/fpm-info.sh"
258   fi
259   if [[ -e "$FPM_INFO" ]]; then
260       debug_echo "Loading fpm overrides from $FPM_INFO"
261       source "$FPM_INFO"
262   fi
263   for i in "${fpm_depends[@]}"; do
264     COMMAND_ARR+=('--depends' "$i")
265   done
266   for i in "${fpm_exclude[@]}"; do
267     COMMAND_ARR+=('--exclude' "$i")
268   done
269
270   # Append remaining function arguments directly to fpm's command line.
271   for i; do
272     COMMAND_ARR+=("$i")
273   done
274
275   COMMAND_ARR+=("${fpm_args[@]}")
276
277   COMMAND_ARR+=("$PACKAGE")
278
279   debug_echo -e "\n${COMMAND_ARR[@]}\n"
280
281   FPM_RESULTS=$("${COMMAND_ARR[@]}")
282   FPM_EXIT_CODE=$?
283
284   fpm_verify $FPM_EXIT_CODE $FPM_RESULTS
285 }
286
287 # verify build results
288 fpm_verify () {
289   FPM_EXIT_CODE=$1
290   shift
291   FPM_RESULTS=$@
292
293   FPM_PACKAGE_NAME=''
294   if [[ $FPM_RESULTS =~ ([A-Za-z0-9_\.-]*\.)(deb|rpm) ]]; then
295     FPM_PACKAGE_NAME=${BASH_REMATCH[1]}${BASH_REMATCH[2]}
296   fi
297
298   if [[ "$FPM_PACKAGE_NAME" == "" ]]; then
299     EXITCODE=1
300     echo "Error: $PACKAGE: Unable to figure out package name from fpm results:"
301     echo
302     echo $FPM_RESULTS
303     echo
304   elif [[ "$FPM_RESULTS" =~ "File already exists" ]]; then
305     echo "Package $FPM_PACKAGE_NAME exists, not rebuilding"
306   elif [[ 0 -ne "$FPM_EXIT_CODE" ]]; then
307     echo "Error building package for $1:\n $FPM_RESULTS"
308   fi
309 }
310
311 install_package() {
312   PACKAGES=$@
313   if [[ "$FORMAT" == "deb" ]]; then
314     $SUDO apt-get install $PACKAGES --yes
315   elif [[ "$FORMAT" == "rpm" ]]; then
316     $SUDO yum -q -y install $PACKAGES
317   fi
318 }